/** trans.c *********************************************** 17.10.2006 **/
/*
  Provereno na BC++ 3.1
  Model pamqti Large + plavajuwja arifmetika

  Universalny dosovski transliterator
  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  Proga TRANS, osuwestvlaet kak postrocnu transliteratsiu s konsoli,

               trans fajl_zamen

  tak i transliteratsiu tselogo fajla source, v poslednem slucae vyzov:

               trans fajl_zamen source result

  Fajl zamen iwetsa snacala v tekuwej direktorii, a esli ego tam net,
  to v direktorii, gde najdena proga TRANS.EXE

  Fajl zamen sostoit iz trjoh castej

  1. zameny po defoltu
  2. stroki kontekstnoj zameny
  3. kommentarii

  Obqzatelnymi qvlajutsa tolko dve pervye stroki opredelajuwie zamenu po
  defoltu. Snacala zadaem stroku bajtov, kaxdyj iz kotoryh podlexat zamene,
  a srazu pod nej stroku bajtov na kotorye zamenqem (bajt na bajt).
  Obe stroki, ponqtnoe delo, dolxny imetj odinakovu dlinu.

  Pervye bajty etih strok imejut osoboe znacenie, oni ne dla zameny ukazany.
  Esli transliteriruetsa html-dokument, to nado v pervyh bajtah pomestitj
  '<' i '>', togda tekst vnutri uglovyh skobok <...> perevoditsa ne budet.

  Esli xe v pervyh bajtah ukazano cto-libo drugoe, to ih soderximoe
  ignoriruetsa. Rekomenduju ukazyvatj simvoly '0'.

  Kstati, moq proga moxet zamenitj luboj nenulevoj bajt na luboj drugoj
  nenulevoj. Nulevoj bajt menqtj nelzq.

  Simvol '0' zamenitj moxno, esli on ukazan ne v nacale stroki.

  Esli v kaxdoj iz pervyh dvuh strok ukazatj _edinstvennyj_ simvol
  (skaxem, '0'), to zamen po defoltu nikakih ne budet.

  Posle dvuh obqzatelnyh strok moxno zadatj stroki kontekstnoj zameny,
  pricom oni dudut primenqjutsa v _pervu oceredj_, do zamen po defoltu

  Struktura stroki kontekstnoj zameny:

             dano[+L(...)][+R(...)]:rezultat

  dano     - zamenqema podstroka, ne pustaq
  rezultat - na cto menqem "dano", eta stroka moxet bytj pustoj
  Obe eti podstroki mogut soderxatj _probely_
  i simvoly granitsy stroki "\r\n"

  Optsionalno ukazyvaem nabory _odinocnyh_ simvolov, kotorye dolxny stoqtj
  sleva (L) ili sprava (R) ot 'dano'

  Esli vmesto +L() napisatj -L(), to etim opredelim, kakie simvoly
  _ne_ dolxny stoqtj sleva ot 'dano', ctoby stroka zameny srabotala

  Analogicno nado ponimatj -R().

  Esli my hotim, ctoby simvoly '+', '-', ')' ili ':' ne rassmatrivalisj
  kak upravlajuwie, to stavim pered nimi "obratny slew" >>\<<, kotoryj
  vypolnqet rolj ekrana. Dvojnoj slew >>\\<< ponimaetsa kak odinocnyj
  neekranirujuwi slew.

  V strokah zameny moxno tak oboznacitj ogranicitelnye bajty:
  \r - vozvrat karetki (13)
  \n - perevod stroki (10)

  Stroka kontekstnoj zameny moxet bytj okruxena pustymi strokami
  ili strokami, kotorye ne soderxat ':' (ih moxno scitatj kommentariem)

  Esli v fajle zamen vsrecaetsa stroka "---", to ego scityvanie prekrawaetsa
  i stroki nixe moxno scitatj kommentariem

  Esli tekuwi kusok ishodnogo fajla ne perevoditsa ni odnoj strokoj zameny,
  to pytaemsa zamenitj bajt po defoltu, esli xe ego _ne_ okazyvaetsa
  v _pervoj_ stroke fajla zamen, to prosto _kopiruem_ etot bajt
  v rezultirujuwi fajl.

  Ogranicenia na dlinu stroki vhodnogo fajla net, poskolku on scityvaetsa
  ne postrocno, a pobajtovo v binarnom rexime.

  Moxno poprobovatj zamenitj slova v exe-fajle na slova toj xe dliny,
  ocevidno, slova ili frazy ne dolxny bytj korotkimi, ctoby ne zamenitj
  liwnego v kode progi. Kolicestvo proizvedjonnyh kontekstnyh zamen
  vyvoditsa na ekran.

  Ogranicenia:
  ~~~~~~~~~~~~
  Fajl zamen dolxen bytj dosovskim fajlom c \r\n na kontse strok
  V fajle zamen stroki ne mogut bytj dlinnee 256 simvolov (bez ucota \r\n)

  V pervyh dvuh strokah "zamen po umolcaniy" nedopustim '\0'

  V strokah kontekstnyh zamen nedopustim nulevoj bajt '\0' i bajt '\1'.
  Stroka 'dano' ne dolxna bytj pustoj
  Dlina strok 'dano', 'rezultat' i strok vnutri skobok L(), R() ne bolee 79
  Kolicestvo strok kontekstnoj zameny - 180 maksimum

  Pri scityvanie _s konsoli_, obrabotka vhodnoj informatsii proishodit
  postrocno, ctoby srazu videtj rezultat transiteratsii posle naxatia
  Enter, pri etom voznikajut ponqtnye ogranicenia na ispolzovanie \r\n
  v strokah kontekstnoj zameny.

  Dlinnyh imjon fajlov moq dosovska proga ne ponimaet, tolko (8+3).
  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  V kacestve primera privoxu fajl zamen dla sverhekonomnogo translita RV4:

  <񦧨
  >abvgdeoxzijklmnoprstufhcwwjyjeuqABVGDEOXZIJKLMNOPRSTUFHCWWJYJEUQ

  // vywe dany zameny po defoltu, oni rabotajut v poslednju oceredj
  // znaki <> v pervyh bajtah nuxny tolko dla html,
  // ctoby ne menqtj soderximoe tegov <...>;
  // inace postavj tam '0'

  // bukvy '' i '' - osoby slucaj, ispolzuem digrafy

  :ts
  -R():wj

  // mqgki znak sohranqem v razdelitelnoj funk7ii
  // i tam gde on realno smqgcaet, inace - udalaem

  +L():
  +L(竘)-R(뀟𝅈):

  // okoncania vozvratnyh glagolov uprowjaem

  +R(\r\n .,?!:;`'"([{}]\)):tsa
  +R(\r\n .,?!:;`'"([{}]\)):sa

  // uprowjonnoe napisanie okoncanij (prilagatelnyh v osnovnom)

  +R(\r\n .,?!:;`'"([{}]\)):a
  +R(\r\n .,?!:;`'"([{}]\)):q
  +R(\r\n .,?!:;`'"([{}]\)):u
  +R(\r\n .,?!:;`'"([{}]\)):ju
  +R(\r\n .,?!:;`'"([{}]\)):i
  +R(\r\n .,?!:;`'"([{}]\)):y

  // glasnye posle fiksirovannoj mqgkosti/tvjordosti

  -L(竨ꘆ):ju
  -L(竨ꘆ):jo
  +L(竨ꘆ):a
  +L():y

  // to xe samoe, no dla bolwih bukv

  :TS
  -R():WJ

  +L():
  +L(竘)-R(뀟𝅈):

  +R(\r\n .,?!:;`'"([{}]\)):TSA
  +R(\r\n .,?!:;`'"([{}]\)):SA

  A+R(\r\n .,?!:;`'"([{}]\)):A
  +R(\r\n .,?!:;`'"([{}]\)):Q
  +R(\r\n .,?!:;`'"([{}]\)):U
  +R(\r\n .,?!:;`'"([{}]\)):JU
  +R(\r\n .,?!:;`'"([{}]\)):I
  +R(\r\n .,?!:;`'"([{}]\)):Y

  -L(竨ꘆ):JU
  -L(竨ꘆ):JO
  +L(竨ꘆ):A
  +L():Y
  ---
*/

#include  <stdio.h>
#include <string.h>
#include <stdlib.h>

/***/                                                       // po defoltu
char          dano[259];                            // zamenqemye simvoly
char        zamena[259];                           // zamenqjuwie simvoly
int            html = 0;                                // 1 - rexin html
int            sliv = 0;        // 1 - v uglovyh skobkah nicego ne menqtj

char      left[180][80];                                 // levye simvoly
char     right[180][80];                                // pravye simvoly
char      base[180][80];                                    // zamenqemoe
char       cel[180][80];                                 // na cto menqem

int         f_left[180];                                    // znak levyh
int        f_right[180];                                   // znak pravyh

int                kzam;           // kolicestvo strok kontekstnoj zameny
/***/
int     end_of_file = 0;                    // 1 - obnaruxen konets fajla
                                                // 2 - konets vsej raboty
char            box[80];                        // bufer vhodnyh simvolov
int        box_max = 80;        // maksimalnoe cislo simvolov v korobocke
int         box_len = 0;            // tekuwee cislo simvolov v korobocke
int           shift = 0;  // cislo simvolov, tolko cto obrabotannyh v box
/***/
unsigned long  n_in = 0;                     // scotcik zamenqemyh bajtov
unsigned long n_out = 0;              // scotcik polycennyh iz nih bajtov
unsigned long n_zam = 0;              // scotcik polycennyh iz nih bajtov
float             v = 0;                       // plavajuwjaq dla delenia
/***/
int read_zam(char *str, int *p_len_str, FILE *fzam)
// procitatj stroku iz _fajla zamen_, otkinutj \r\n, opredelitj dlinu
// vozvrat 1 - konets fajla, inace - 0
// no esli stroka dlinee 256 simvolov - avarijnoe zaverwenie
// v stroke str[] dolxno bytj mesto dla 259 bajt
// v fajle zamen stroki dolxny koncatsa na \r\n, bytj moxet krome poslednej
{
   int len = 0;

   if (fgets(str, 259, fzam) == 0)                   // 256 + 2 + 1 = 259
      return (1);                                    // ... \r\n  0
                                                       // open(..., "rb")
   len = strlen(str) - 2;                                   // len <= 256
   if (len == 256 && !(str[len] == '\r' && str[len + 1] == '\n')) {
      fprintf(stderr, "!! Ploho, stroka dlinee 256 simvolov\n%s\n", str);
      fclose(fzam);
      exit (1);
   }

   if (str[len] != '\r')              // poslednq stroka v fajle bez \r\n
      len += 2;                                        // takoe dopustimo

   str[len] = 0;
   *p_len_str = len;
   return (0);
}

int f_len_kon(char *s)
// opredelaem dlinu kon7a iz spiska kon7ov
// priznak kon7a kon7a - '\0' ili '\1'
{
  int i = 0;

  for (; s[i]; i++) {
     if (s[i] == '\1')
        return (i);
  }
  return (i);
}

int copy(char scel[], int max, char sline[], char kontsy[])
// kopiruem nacalo stroki 'sline' v stroku 'scel' ne bolee 'max' simvolov
// spisok vozmoxnyh kontsov soderxitsa v 'kontsy': kon1(\1)kon2(\1)...konN
// vozvrawjaem dlinu skopirovannoj casti (smewenie sledujuwego bajta sline[])
{
   char  *p[10];                 // ukazateli na kontsy, realno 5 maximum
   int  ik =  0;                                        // indeks kontsov
   int ikm = -1;                // kanom kontsov, vozmoxno ih spisok pust

   int   i =  0;                                                // indeks
   int   j =  0;                                                // indeks
   char  c =  0;                                                // simvol

   if (kontsy[0]) {                  // ustanavlivaem ukazateli na kontsy
      p[0] = kontsy;
      for (i = 1; kontsy[i]; i++) {
         if (kontsy[i] == '\1')
            p[++ik] = kontsy + i + 1;
      }
      ikm = ik;
   }
   for (i = 0; sline[i]; i++) {             // kopiruem do pervogo kontsa
                  // v sline vyrezam '\\', zamenqem \r(na 13) i \n(na 10)
      if (sline[i] == '\\' && (c = sline[i + 1]) != 0) {
         j = i; do sline[j] = sline[j + 1]; while (sline[++j]);
         if      (c == 'r') sline[i] = 13;
         else if (c == 'n') sline[i] = 10;
         continue;    // simvol '\\' ne da0t obnaruxitj kone7, ekraniruet
      }                                    // iwem pervyj podhodqwi kone7
      for (ik = 0; ik <= ikm; ik++) {
         if (strncmp(sline + i, p[ik], f_len_kon(p[ik])) == 0)
            goto COPY;
      }
   }                               // end of "for (i = 0; sline[i]; i++)"
                       // kopiruem do pervogo kontsa ili 'sline' tselikom
COPY:
   if (i > max) {
      fprintf(stderr,
         "!! Ploho, moxem skopirovatj tolko %d simvolov iz\n%s\n---\n",
                                              max,            sline);
      i = max;
   }
   strncpy(scel, sline, i);
   scel[i + 1] = 0;
   return (i);
}

void parsing(char line[], int icont)
// dano[+L(...)][+R(...)]:rezultat
// razbor stroki kontekstnoj zameny 'line'
// zadan nomer 'icont'
// casti vydelaem i vyvodim v extern massivy: base[], cel[], ...
{
   int  iline = 0;                                      // index v line[]
   char cznak = 0;                                             // + ili -
   char cnext = 0;                                             // L ili R

   f_left[icont]  = 0;                       // poka net levogo konteksta
   f_right[icont] = 0;                      // poka net pravogo konteksta

   iline = copy(base[icont], 79, line, "+L(\1-L(\1+R(\1-R(\1:");
   if (iline == 0) {
      fprintf(stderr,
      "!! Ploho, zamenqema podstroka ne dolxna bytj pustoj:\n%s\n", line);
      exit(1);
   }

NEXT:
   cznak = line[iline];
   cnext = line[iline + 1];
   if (cznak == ':') {                                       // :rezultat
      copy(cel[icont], 79, line + iline + 1, "");
      return;                         // tolko zdesj normalnoe zaverwenie
   }
   if (cnext == 'L') {                                         // +L(...)
      if (cznak == '+')
         f_left[icont] =  1;
      else
         f_left[icont] = -1;
      iline += 3 + copy(left[icont], 79, line + iline + 3, ")") + 1;
      goto NEXT;
   }
   if (cnext == 'R') {                                         // +R(...)
      if (cznak == '+')
         f_right[icont] =  1;
      else
         f_right[icont] = -1;
      iline += 3 + copy(right[icont], 79, line + iline + 3, ")") + 1;
      goto NEXT;
   }
                                  // perestrahovka, takogo bytj ne dolxno
   fprintf(stderr,
      "!! Ploho, ne obnaruxen obqzatelny ':' v stroke zameny: \n%s"
      "\n---\n", line);
   cel[icont][0] = 0;
   return;
}

void next_box(FILE *fin)
// korobocka nuxna, ctoby moxno bylo proveritj i samuju dlinnuju zamenu
// zamena moxet vklucatj grani7u stroki (daxe neskolko)
// dlina stroki vhodnogo fajla nicem ne ogranicena
// popolnqem korobocku box do ejo predela
// ili do upora v konets (stroki ili fajla)

// end_of_file = 2, konets fajla pri pustoj korobocke
// end_of_file = 1, konets fajla obnaruxen, no korobocka ne pusta

// predpolagaem, cto slovo ne razryvaetsa na granitse stroki

// esli vvodim _s konsoli_,
// to ne perehodim k scityvaniu novoj stroki poka korobocka ne opusteet
// i rezultat transliteratsii stroki ne budet vyveden

// v slucae html soderximoe korobocki ograniceno '<'
{
   int c = 0;                                           // tekuwij simvol

   if (end_of_file) {                 // iz fajla scityvatj bolwe necego
      if (box_len == 0)
         end_of_file = 2;                           // konets vsej raboty
      return;
   }

   if (                                    // priznajom razdelitel stroki
        box_len > 0      // ne perehodim na novuju, poka korobka ne pusta
        &&
        (
          (fin == stdin && box[box_len - 1] == '\n')
          ||                                          // ogranicitel html
          (html && box[box_len - 1] == '<')
        )
      )
      return;

   while (box_len < box_max) {                    // dozapisj v korobocku
      c  = getc(fin);
      if (c == EOF) {                                     // konets fajla
         end_of_file = 1;                      // v korobocku ne popadaet
         if (box_len == 0)
            end_of_file = 2;                    // zaverwenie vsej raboty
         break;
      }
      box[box_len++] = c;
      if (fin == stdin && c == '\n')                // razdelitel takxe transliteriruetsa
         break;                          // no on ogranicitel v korobocke
      if (html && c == '<')
         break;                                       // ogranicitel html
   }
}

void translate_box(FILE *fout)
// provodim translit odnoj ili neskolkih bukv, nakoplennyh v box
// snacala kontekstye zameny, potom po defoltu ili prosto kopiruem
// rezultat pecataem v vyhodnoj fajl
{
   int     l_base = 0;                          // dlina zamenqemoj casti
   int          i = 0;                                          // indeks
   char        *p = 0;                    // ukazatel na simvol v massive
   static int ca = -1;         // poslednij na sejcas perevedjonn simvol

   if (sliv) {         // infu v uglovyh skobkah ne trogaem v rexime html
      for (i = 0; i < box_len; i++) {
         putc(box[i], fout);
         if (box[i] == '>') {
            i++; sliv = 0;                                // konets sliva
            break;
         }
      }
      ca = box[i - 1];
      shift = i;
      return;
   }

   if (html && box[0] == '<') {            // v rexime html vklucaem sliv
      putc('<', fout);
      ca        = '<';
      shift       = 1;
      sliv        = 1;
      return;
   }

   for (i = 0; i < kzam; i++) {                 // kontekstny podstanovki

      l_base = strlen(base[i]);
      if (
          (strncmp(box, base[i], l_base) == 0)
          &&
          (
           ( f_left[i] == 0 )
           ||
           ( (f_left[i] > 0) &&  strchr(left[i], ca) )
           ||
           ( (f_left[i] < 0) && !strchr(left[i], ca) )
          )
          &&
          (
           ( f_right[i] == 0 )
           ||
           ( (f_right[i] > 0) &&  strchr(right[i], box[l_base]) )
           ||
           ( (f_right[i] < 0) && !strchr(right[i], box[l_base]) )
          )
         )
      {
         fprintf(fout, "%s", cel[i]);
         shift = l_base;
         ca = base[i][l_base - 1];
         n_in += shift;
         n_out += strlen(cel[i]);
         n_zam++;
         return;
      }
   }
                                                  // teperj prosta zamena
   shift = 1;                       // dalee obrabatyvaem po odnomu bajtu
   ca = box[0];                                    // novy predwestvujuwi

   p = strchr(dano + 1, ca);
   if (p && ca) {       // zamena nenulevogo simvola na simvol po defoltu
      putc(zamena[ (int)(p - dano) ], fout);
      n_in++;                                        // prirost scotcikov
      n_out++;
   }
   else                                        // bajt zamene ne podlexit
      putc(ca, fout);
}

void shift_box()
// sdvigaem soderximoe "box" vlevo, izmenqem 'box_len'
// tem samym zatiraq pereved0nnoe
// nulevoj bajt na kon7e vaxen pri sravnenii strok
{
   int i = 0;                                                   // indeks

   for (i = shift; i < box_len; i++)
      box[i - shift] = box[i];
   box_len -= shift;
   box[box_len] = 0;
}

FILE *myfopen(
// pytaemsa otkrytj fajl zamen snacala v tekuwej direktorii
// a potom v direktorii, gde raspoloxena proga TRANS
char *prgn,                                // imq progi TRANS s marwrutom
char *fn)                                              // imq fajla zamen
{
   char newn[80];
   FILE   *f = 0;
   int     i = 0;

   if ((f = fopen(fn, "rb")) != 0) {
      fprintf(stderr, " %s\n", fn);
      return (f);
   }
   strncpy(newn, prgn, 80);
   newn[79] = 0;
   for (i = strlen(newn); newn[i - 1] != '\\'; i--);
   newn[i] = 0;
   if (i + strlen(fn) < 80)
      strcat(newn, fn);
   else {
      fprintf(stderr,
         "!! Imq fajla zamen s marwrutom dalo by bolee 80 bajtov\n");
      exit(1);
   }
   f = fopen(newn, "rb");
   fprintf(stderr, " %s\n", newn);
   return (f);
}

int main(int argc, char *argv[])
// po kusockam scityvaem vhodnoj potok i transliteriruem
// v kontse podscityvaem vybuhanie
{
   FILE  *fzam =      0;                        // ukazatel na fajl zamen
   FILE   *fin =  stdin;                      // ukazatel na ishodny fajl
   FILE  *fout = stdout;                     // ukazatel na vyhodnoj fajl

   int        ldano = 0;                                  // dlina 'dano'
   int      lzamena = 0;                                // dlina 'zamena'

   char       line[259];                     // stroka kontekstnoj zameny
   int       l_line = 0;                                  // dlina 'line'
   int        icont = 0;              // indeks stroki kontekstnoj zameny

   fprintf(stderr, "\n"
 ">> TRANS. 17 okt 2006. Nikolaj Mihajlenko (Moskva). http://mi.anihost.ru"
 "\n>> %s", argv[0]);

   if (argc < 2) {                                  // razborka s fajlami
      fprintf(stderr,"\n!! Zadaj fajl zamen. Opisalovo v \"trans.c\"\n");
      return (1);
   }

   fzam = myfopen(argv[0], argv[1]);
   if (fzam == 0) {
      fprintf(stderr, "!! Ne mogu otkrytj fajl zamen \"%s\"\n", argv[1]);
      return (1);
   }

   if (read_zam(dano, &ldano, fzam)) {
      fprintf(stderr, "!! Ne zadana stroka simvolov, podlexawih zamene\n");
      fclose(fzam);
      return (1);
   }

   if (read_zam(zamena, &lzamena, fzam)) {
    fprintf(stderr, "!! Ne zadana stroka simvolov, na kotorye zamenqem\n");
      fclose(fzam);
      return (1);
   }

   if (ldano != lzamena) {
      fprintf(stderr, "!! Nacalnye dve stroki zameny po defoltu "
             "dolxny imetj ravnu dlinu\n%s\n%s\n", dano, zamena);
      fclose(fzam);
      return (1);
   }
                                  // v uglovyh skobkah tekst ne perevodim
   if (dano[0] == '<' && zamena[0] == '>')
      html = 1;

   for (icont = 0; icont < 180; icont++) {
      if (
           read_zam(line, &l_line, fzam)         // scitatj stroku zameny
           ||
           (strcmp(line, "---") == 0)         // ogranicitel spiska strok
         )
         break;
      if (l_line == 0 || strchr(line, ':') == 0) {
         icont--; continue;               // pusta stroka ili kommentarij
      }
      parsing(line, icont);                       // razbor stroki zameny
   }
   kzam = icont;
   if (kzam == 180)
      fprintf(stderr, ">> Vybrali limit na stroki zamen, vsego 180 \n");

   fprintf(stderr,
      ">> Vvedeno strok kontekstnoj zameny vsego %d. Maksimum 180\n", kzam);
   if (ldano > 1)
      fprintf(stderr,
         ">> Po umolcaniu zamenqjutsa simvoly:\n>>   %s\n"
         ">> pobajtovo na simvoly:\n>>   %s\n", dano + 1, zamena + 1);
   else
      fprintf(stderr, ">> Net simvolov zamenqemyh po umolcaniu\n");
   if (html)
      fprintf(stderr, ">> Simvoly vnutri <...> ne zamenqjutsa\n");
   else
      fprintf(stderr, ">> Uglovym skobkam <...> osoboj roli ne dajom\n");

   if (argc > 2) {
      fin = fopen(argv[2], "rb");
      if (fin == 0) {
         fprintf(stderr, "!! Ne mogu otkrytj ishodny fajl \"%s\"\n",
                                                              argv[2]);
         fclose(fzam);
         return (1);
      }
   }

   if (argc > 3) {
      fout = fopen(argv[3], "wb");
      if (fout == 0) {
         fprintf(stderr, "!! Ne mogu otkrytj vyhodnoj fajl \"%s\"\n",
                                                               argv[3]);
         fclose(fzam);
         fclose(fin);
         return (1);
      }
   }

   if (fin != stdin)
      fprintf(stderr,
         "\n!! Xdite ... Preryvanie po Control-C\n");
   else
      fprintf(stderr,
         "\n!! Vvodite stroki dla perevoda ... Konets po Control-Z\n\n");

   while (1) {                                               // sutj dela
      next_box(fin);                              // dozapisj v korobocku
      if (end_of_file == 2)          // konets fajla pri pustoj korobocke
         break;                                        // normalnyj vyhod
      translate_box(fout);       // transliteratsia soderximogo korobocki
      shift_box();                              // udalenie obrabotannogo
   }

   if (n_in == 0) {                                    // vyvod podscotov
      fprintf(stderr, "\n" ">> Ne bylo zamenqemyh bajtov na vhode\n");
      return (0);
   }

   v = n_out;
   v = ((v / n_in) - 1) * 100;
   fprintf(stderr, "\n"
 ">> Bylo vvedeno %lu zamenqemyh bajtov, iz nih polucilosj %lu simvolov\n"
 ">> Kontekstnyh zamen bylo %lu. Vybuhanie ravno %3.1f%%\n",
      n_in, n_out, n_zam, v);
   return (0);
}
/** end of trans.c ******************************************************/
